#include "changesdialogimpl.h"

#include <qtextbrowser.h>

/* 
 *  Constructs a changesdialog which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ChangesDialog::ChangesDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : ChangesDialogBase( parent, name, modal, fl )
{
  changes_view->setText("<h3> 0.0.4: </h3>\n"
"<!-- ============= -->\n"
"\n"
"<ul>\n"
"    <li> gui now spawns a new engine process if connect fails </li>\n"
"\n"
"    <li> changed names of menu-items in the gui </li>\n"
"\n"
"    <li> added icon and about dialog to the gui </li>\n"
"\n"
"    <li> changed graph format. Old graphs will not work. </li>\n"
"\n"
"    <li> changed image source: removed automatic seeking and\n"
"         changed from an [0,1] position input to [0, num_frames-1] position\n"
"         input</li>\n"
"       \n"
"    <li> frboutmodule (unix only): ximage, xshm and gl output driver now use\n"
"         the DISPLAY environment variable if their display-property is set\n"
"         to \"default\"</li>\n"
"\n"
"    <li> removed debug messages </li>\n"
"\n"
"    <li> added the ifs (iterated function system) effects to the win32\n"
"         version</li>\n"
"\n"
"    <li> merged config files engine.conf and gui.conf to gephex.conf </li>\n"
"\n"
"    <li> added wrapper script for better installation (example graphs are\n"
"         installed under linux now, too) </li>\n"
"\n"
"    <li> fixed several bugs (some listed below)\n"
"        <ul>\n"
"            <li> fixed radio button</li>\n"
"\n"
"            <li> frboutmodule: crash if depth of the xserver is not 32 </li>\n"
"\n"
"            <li> frboutmodule: crash when using xshm driver on remote xserver </li>\n"
"\n"
"            <li> isingnoize: crash when input size is set to zero</li>\n"
"\n"
"            <li> engine: memory leaks</li>\n"
"\n"
"            <li> network: fixed endianess issue in the protocol </li>\n"
"\n"
"        </ul>\n"
"    </li>\n"
"\n"
"    <li> changed from debug to release target for engine and gui on win32\n"
"         (unix version already was non-debug per default)</li>\n"
"</ul>\n"
"\n"
"<hr>\n"
"\n"
"<h3>0.0.4beta2</h3>\n"
"<!-- ============= -->\n"
"\n"
"<ul>\n"
"    <li> removed nonfunctional and unneeded code\n"
"        <ul>\n"
"             <li> sequencer</li>\n"
"             <li> playlist</li>\n"
"             <li> tons of old and unneeded code</li>\n"
"             <li> folders for graphs</li>\n"
"        </ul>\n"
"    </li>\n"
"            \n"
"    <li> fixed several open bugs\n"
"        <ul>\n"
"             <li> fixed crash when deleting module that is connected\n"
"                  to a patched input</li>\n"
"             <li> fixed bug that moved modules in the grapheditor</li>\n"
"             <li> fixed engine crash when gui disconnects</li>\n"
"             <li> fixed bug in protocol when the datareceiver throws an\n"
"                  exception</li>\n"
"             <li> enhanced robustness of protocol (resync)</li>\n"
"             <li> fixed \"lost value\" problem of spinbox widget</li>\n"
"        </ul>\n"
"    </li>\n"
"\n"
"    <li> gui and engine now run independent, when one app crashes\n"
"         the other one continues </li>\n"
"\n"
"    <li> gui can detach from engine and reconnect later</li>\n"
"\n"
"    <li> improved startup speed (loading the plugins took very long before)</li>\n"
"    <li> new modules:\n"
"        <ul>\n"
"             <li> font module that can use any true type font (uses\n"
"              sdl_ttf)</li>\n"
"             <li> several more effecTV ports (sparkTV, quarkTV, ...)</li>\n"
"             <li> pixelizer effect</li>\n"
"        </ul>\n"
"    </li>\n"
"\n"
"    <li> new gl output driver in frboutmodule (uses textures)</li>\n"
"\n"
"    <li> more bugfixes and small improvements in engine, gui and modules</li>\n"
"\n"
"</ul>\n"
"\n"
"<hr>\n"
"\n"
"<h3>0.0.4alpha2</h3>\n"
"<!-- ============= -->\n"
"\n"
"<ul>\n"
"    <li> audio type and some audio modules (beat detection works, but it's\n"
"         still pretty dumb) </li>\n"
"\n"
"    <li> Grapheditor shows icons of the modules now</li>\n"
"\n"
"    <li> merged several modules for better usability:\n"
"         (plz see README if you want to convert old graphs)\n"
"        <ul>\n"
"            <li> all framebuffer outputs are merged into frboutmodule\n"
"             (the same module for linux and windows, this way\n"
"              the graphs are more portable) [note that some outputs\n"
"              like glout and sdlout are commented out for the moment\n"
"              due to their bad performance]</li>\n"
"\n"
"            <li> bmpmodule, avifilemodule, libmpeg3loader, videomodule,\n"
"             directshowmodule are merged into frbinmodule\n"
"             (again only one module for all plattforms)</li>\n"
"\n"
"            <li> addmodule and submodule have been merged into arithmodule\n"
"             (which now can do a lot more than just addition and\n"
"              subtraction)</li>\n"
"\n"
"            <li> imgmulmodule, imgaddmodule, imgsubmodule, invertmodule\n"
"                have been fixed and merged into imgarithmodule</li>\n"
"        </ul>\n"
"    </li>\n"
"\n"
"    <li> all framebuffer output drivers now support control over\n"
"         brightness, contrast, gamma </li>\n"
"\n"
"    <li> new aalib driver in frboutmodule</li>\n"
"\n"
"    <li> new modules:\n"
"        <ul>\n"
"             <li> gradnormmoule  : shows the edges of an image</li>\n"
"             <li> twolayermodule : turns an image to black and white</li>\n"
"             <li> audio(in|out)module : in and output, supports alsa and os\n"
"               on posix platforms and wavein/out on win32</li>\n"
"             <li> audiobdmodule  : simple beat detection</li>\n"
"        </ul>\n"
"    </li>\n"
"\n"
"    <li> default graph is now edited and rendered graph at startup</li>\n"
" \n"
"    <li> removed output size from rotary zoomer, the size of the input\n"
"         framebuffer is used instead</li>\n"
"\n"
"    <li> new check-box property widget</li>\n"
"\n"
"    <li> fixed some bugs and glitches</li>\n"
"\n"
"</ul>\n"
"\n"
"<hr>\n"
"\n"
"<h3>0.0.4alpha1</h3>\n"
"<!-- ============= -->\n"
"    \n"
"<ul>\n"
"    <li> NumberType changed from unsigned int (32 bit) to\n"
"         IEEE 64 bit floating point value.\n"
"         This changes nearly all effects.</li>\n"
"    \n"
"    <li> Many bugfixes</li>\n"
"    \n"
"    <li> Color-format and framebuffer orientation fixed to\n"
"         BGRA top down (i.e. first line in memory ist upper most line)</li>\n"
"    \n"
"    <li> Ported some effects from EffecTV</li>\n"
"    \n"
"    <li> Improved the build system (library tests etc.)</li>\n"
"    \n"
"    <li> Midiinput now works for Linux and WIN32</li>\n"
"    \n"
"    <li> Updated the documentation</li>\n"
"\n"
"    <li> Avifile support for Linux</li>\n"
"\n"
"    <li> Isingnoize and IFS effects</li>\n"
"\n"
"    <li> Better control- and propertywidgets (refactored them to use common\n"
"         code)</li>\n"
"\n"
"</ul>\n"
"\n"
"<hr>\n"
"    \n"
"<h3>0.0.3</h3>\n"
"<!-- ============= -->\n"
"    \n"
"<ul>\n"
"    <li> Fixed countless bugs </li>\n"
"    \n"
"    <li> Reworked network code (support for unix domain sockets + namedpipes)</li>\n"
"</ul>\n"
);

}

/*  
 *  Destroys the object and frees any allocated resources
 */
ChangesDialog::~ChangesDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

